<?php

// +------------------------------------------------------------------+
// | Package Information                                              |
// +------------------------------------------------------------------+

/**
 * @package     EuropaCart
 * @subpackage  JFramework
 * @copyright   Copyright 1999-Present Kryptronic, Inc.  All rights reserved.
 * @link        http://www.kryptronic.com
 * @license     GNU/GPL
*/

// +------------------------------------------------------------------+
// | Package                                                          |
// +------------------------------------------------------------------+

// +--
// | No direct access.
// +--

defined('_JEXEC') or die ('Restricted access');

// +--
// | Import the plugin controller.
// +--

jimport( 'joomla.plugin.plugin' );

// +------------------------------------------------------------------+
// | Class Definition                                                 |
// +------------------------------------------------------------------+

class plgAuthenticationEuropaCart extends JPlugin {

// +--
// | EuropaCartCommon class variable.
// +--

var $EuropaCartCommon;

// +------------------------------------------------------------------+
// | Function: Constructor                                            |
// +------------------------------------------------------------------+

function plgAuthenticationEuropaCart(&$subject, $config) {

parent::__construct($subject, $config);

// +--
// | Load the EuropaCartCommon class from the EuropaCart_ObjectCache
// | so we can access common libraries.
// +--

global $EuropaCart_ObjectCache;

$this->EuropaCartCommon =& $EuropaCart_ObjectCache['EuropaCartCommon'];

} // End of function.

// +------------------------------------------------------------------+
// | Function: onUserAuthenticate                                     |
// +------------------------------------------------------------------+

function onUserAuthenticate ($credentials = array(), $options = array(), &$response) {

// +--
// | This method should handle any authentication and report back 
// | to the subject.  Used for Joomla 2.5 and higher.
// |
// | param	array	$credentials	Array holding the user credentials
// | param	array	$options	Array of extra options
// | param	object	$response	Authentication response object
// +--

// +--
// | Check the connection status.
// +--

global $EuropaCart_ConnectionActive;

if ((!(empty($EuropaCart_ConnectionActive))) || (empty($this->EuropaCartCommon))) {

     return false;

} // End of if statement.

global $EuropaCart_ForceAddUser;

// +--
// | Build the XML request.
// +--

$xmlrequest  = array('xml.0' => array('app.0'       => 'core',
                                      'namespace.0' => 'joomlasinglesignon',
                                      'params.0'    => $credentials));

$xmlrequest['xml.0']['params.0']['method'] = 'onAuthenticate';

$result = $this->EuropaCartCommon->sendXML($xmlrequest);

if ($result['status'] == 'ERROR') {

     $response->status        = JAuthentication::STATUS_FAILURE;
     $response->error_message = $result['response'];

     return false;

} else {

     $response->status         = JAuthentication::STATUS_SUCCESS;
     $response->error_message  = '';

     $response->username  = $result['response']['username'];
     $response->password  = $result['response']['password'];
     $response->email     = $result['response']['id'];
     $response->fullname  = $result['response']['fname'] . ' ' . $result['response']['lname'];

     $EuropaCart_ForceAddUser = 1;

     return true;

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: onAuthenticate                                         |
// +------------------------------------------------------------------+

function onAuthenticate ($credentials = array(), $options = array(), &$response) {

// +--
// | This method should handle any authentication and report back 
// | to the subject.  Used for Joomla 1.7 and lower.
// |
// | param	array	$credentials	Array holding the user credentials
// | param	array	$options	Array of extra options
// | param	object	$response	Authentication response object
// +--

// +--
// | Check the connection status.
// +--

global $EuropaCart_ConnectionActive;

if ((!(empty($EuropaCart_ConnectionActive))) || (empty($this->EuropaCartCommon))) {

     return false;

} // End of if statement.

global $EuropaCart_ForceAddUser;

// +--
// | Build the XML request.
// +--

$xmlrequest  = array('xml.0' => array('app.0'       => 'core',
                                      'namespace.0' => 'joomlasinglesignon',
                                      'params.0'    => $credentials));

$xmlrequest['xml.0']['params.0']['method'] = 'onAuthenticate';

$result = $this->EuropaCartCommon->sendXML($xmlrequest);

if ($result['status'] == 'ERROR') {

     $response->status        = JAUTHENTICATE_STATUS_FAILURE;
     $response->error_message = $result['response'];

     return false;

} else {

     $response->status         = JAUTHENTICATE_STATUS_SUCCESS;
     $response->error_message  = '';

     $response->username  = $result['response']['username'];
     $response->password  = $result['response']['password'];
     $response->email     = $result['response']['id'];
     $response->fullname  = $result['response']['fname'] . ' ' . $result['response']['lname'];

     $EuropaCart_ForceAddUser = 1;

     return true;

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | End of Class                                                     |
// +------------------------------------------------------------------+

} // End of class.

// +------------------------------------------------------------------+
// | End Of File                                                      |
// +------------------------------------------------------------------+

?>